<template>
  <!-- @todo: Remove this disable -->
  <!-- eslint-disable vue/no-mutating-props -->
  <creation-step
    form-title="Planifier un trajet"
    :previous-step="{ name: 'campus-campus_id-select-type', params: { campus_id: campus.id }}"
    @submit="create"
  >
    <template
      v-if="!user.gprd"
      #alert
    >
      <gprd-warning />
    </template>
    <template #form>
      <fieldset class="fields-box">
        <ec-field
          v-if="!user.phone || !user.phone.confirmed"
          class="phone"
        >
          Si vous souhaitez être notifié sur votre téléphone, vous devez
          <nuxt-link :to="{name: 'my-account-edit-account'}">
            renseigner et confirmer votre numéro de téléphone
          </nuxt-link>
        </ec-field>

        <ec-field
          label="Date et heure de départ"
          field-id="start"
          class="start"
        >
          <client-only>
            <date-time
              id="start"
              v-model="ride.start"
              type="datetime"
              append-to-body
              :disabled-date="dayReservationScope"
              :disabled-time="hourReservationScope"
              lang="fr"
              :show-second="false"
              :minute-step="5"
              confirm
              required
              input-class="input"
              placeholder="Sélectionner une date"
            />
          </client-only>
        </ec-field>

        <ec-field
          label="Nombre de passagers"
          field-id="passengersCount"
          class="passengers"
        >
          <number-input
            id="passengersCount"
            v-model="ride.passengersCount"
            :min="1"
            :max="10"
          />
        </ec-field>

        <ec-field
          label="Présence de bagages"
          field-id="luggage"
          class="luggage"
        >
          <ec-toggle
            v-model="ride.luggage"
          />
        </ec-field>

        <ec-field
          label="Commentaires"
          field-id="userComments"
          class="comments"
        >
          <input
            v-model="ride.userComments"
            maxlength="150"
            type="text"
            class="input"
          >
        </ec-field>
      </fieldset>
      <form-button
        :disabled="!ride.start"
      />
    </template>
    <template #footer>
      <information-icons />
    </template>
  </creation-step>
</template>

<script>
import gprdWarning from '~/components/creation-step/gprd-warning.vue';
import informationIcons from '~/components/informations-icons.vue';
import creationStep from '~/components/creation-step/generic.vue';
import formButton from '~/components/creation-step/form-button.vue';
import numberInput from '~/components/form/number-input.vue';
import ecToggle from '~/components/form/toggle.vue';
import errorsManagement from '~/helpers/mixins/errors-management';
import datePickerMixin from '~/helpers/mixins/date-picker';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Réservez votre e-Chauffeur dès maintenant !';
const SUBTITLE = 'Sélectionner d\'abord une date et renseigner des informations générales.';

export default {
  components: {
    informationIcons,
    creationStep,
    gprdWarning,
    formButton,
    numberInput,
    ecToggle,
  },
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
    errorsManagement(),
    datePickerMixin(),
  ],
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
    ride: {
      type: Object,
      default: () => ({
        start: null,
        luggage: false,
        passengersCount: 1,
        userComments: null,
      }),
    },
  },
  async asyncData({ $api }) {
    const { data } = await $api.query('jwt').setMask('gprd,phone(confirmed)').user();
    return { user: data };
  },
  methods: {
    async create() {
      const ride = {
        ...this.ride,
        campus: this.campus,
      };
      this.handleCommonErrorsBehavior(async () => {
        let data = {};
        const RideQuery = this.$api.query('rides').setMask('id,status').setCampus(this.campus.id);
        if (ride.id) {
          ({ data } = await RideQuery.edit(ride.id, ride));
        } else {
          ({ data } = await RideQuery.create(ride));
        }
        this.$router.push({
          name: 'campus-campus_id-rides-id-select-pois',
          params: {
            campus_id: this.campus.id,
            id: data.id,
          },
        });
      });
    },
  },
};
</script>
<style lang="scss" scoped>
  @import "~assets/css/head";
  .form {
    fieldset {
      display: grid;
      grid-template-columns: repeat(2, 1fr);

      .phone {
        grid-column: 1/3;
        a {
          text-decoration: underline;
          font-weight: 700;
        }
        /deep/ .control {
          text-align: center;
        }
      }
      .start {
        grid-column: 1/3;

        .mx-datepicker {
          width: 100%;
        }
      }

      .passengers {
        grid-column: 1;
      }

      .luggages {
        grid-column: 2;
      }

      .comments {
        grid-column: 1/3;
      }
    }

    @media screen and (max-width: 600px) {
      fieldset {
        display: flex;
        flex-direction: column;
        align-items: center;
        .field {
          width: 100%;
        }
      }
    }
  }

</style>
